#!/bin/bash
cd $(dirname $(readlink -f $0))

#Можно настроить свои каталоги
TEMP="TEMP"
CONF="CONF"
ARCHIVE="ARCHIVE"

rm -f $TEMP/*
RDATE=$(date +"%d.%m.%Y %H:%M")
if [ -z $1 ]; then
#Проверить есть ли новый отчет
curl -s --output $TEMP/claims.txt --cookie $(< $CONF/cookie.txt) https://portal.rfc-revizor.ru/cabinet/myclaims-reports/
FILE=$(grep "/cabinet/claims-reports/download/" $TEMP/claims.txt|head -1|cut -d"/" -f5|cut -d"." -f1)
if [ -z $FILE ]; then
echo "SESSION EXPIRED $RDATE ! Please, update $CONF/cookie.txt" >> exec.log
elif [ -s $ARCHIVE/$FILE.zip ] ; then
echo "PING OK $RDATE" >> exec.log
else
#Загрузить новый отчет
curl -v --output $TEMP/$FILE.zip --cookie $(< $CONF/cookie.txt) https://portal.rfc-revizor.ru/cabinet/claims-reports/download/$FILE.zip
if [ -s $TEMP/$FILE.zip ]; then
echo "SEND REPORT $FILE $RDATE" >> exec.log
cp $TEMP/$FILE.zip $ARCHIVE
unzip $TEMP/$FILE.zip -d $TEMP
#Отправить отчет на e-mail
iconv -f windows-1251 -t utf-8 $TEMP/report.csv > $TEMP/report.txt
if grep -q "Мониторинг не выявил нарушений" $TEMP/report.txt ; then
echo|mutt -e 'my_hdr From: no-reply <no-reply>' -s 'Отчет ревизора: нарушений нет' -- $(< $CONF/emails.txt)
else
GENPR=$(grep -oP "Генпрокуратура;[0-9]+" $TEMP/report.txt|head -1|tr ";" ":")
TOTAL=$(grep -oP "Всего;[0-9]+" $TEMP/report.txt|head -1|tr ";" ":")
echo "<!DOCTYPE HTML><html><head><meta charset=\"utf-8\"><title>Отчет ревизора: $GENPR $TOTAL</title></head><body><p><table border=\"1\"><caption>Отчет ревизора:</caption>" > mail.body
grep -A1000000 "Время обнаружения нарушения" $TEMP/report.txt|awk -F";" '{if($10) {print "<tr><td>"$1"</td><td>"$5"</td><td>"$10"</td><td>"$7"</td></tr>"} else {print "<tr><td>"$1"</td><td>"$5"</td><td>"$6"</td><td>"$7"</td></tr>"}}' >> mail.body
echo "</table></p></body></html>" >> mail.body
mutt -e 'my_hdr From: no-reply <no-reply>' -e 'set content_type=text/html' -s "Отчет ревизора: $GENPR $TOTAL" -- $(< $CONF/emails.txt) < mail.body
fi
fi
fi
else
# Запросить создание нового отчета
echo -n "reportDate=$(date +%d.%m.%Y)" > $TEMP/create.req
curl -s -X POST --cookie $(< $CONF/cookie.txt) --data @$TEMP/create.req https://portal.rfc-revizor.ru/cabinet/myclaims-reports/create
echo "REQUEST REPORT $RDATE" >> exec.log
fi
